﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Runtime.InteropServices;
using System.Security.Principal;
using System.Text;

namespace ConsoleApplication4
{


    class Program
    {

        internal enum LogonType
        {
            LOGON32_LOGON_BATCH = 4,
            LOGON32_LOGON_INTERACTIVE = 2,
            LOGON32_LOGON_NETWORK = 3,
            LOGON32_LOGON_NETWORK_CLEARTEXT = 8,
            LOGON32_LOGON_NEW_CREDENTIALS = 9,
            LOGON32_LOGON_SERVICE = 5,
            LOGON32_LOGON_UNLOCK = 7
        }

        internal enum ProviderType
        {
            LOGON32_PROVIDER_DEFAULT,
            LOGON32_PROVIDER_WINNT35,
            LOGON32_PROVIDER_WINNT40,
            LOGON32_PROVIDER_WINNT50
        }

 



        [DllImport("advapi32.dll", SetLastError = true)]
        internal static extern bool LogonUser(string username, string domain, string password, LogonType lType, ProviderType pType, out IntPtr token);

        [DllImport("advapi32.dll", SetLastError = true)]
        internal static extern bool DuplicateToken(IntPtr existingTokenHandle, int SECURITY_IMPERSONATION_LEVEL, out IntPtr duplicateTokenHandle);

        [DllImport("kernel32.dll")]
        internal static extern bool CloseHandle(IntPtr token);
 



        public static void Invoke(string username, string password, string domain)
        {
            if (domain == null)
            {
                throw new ArgumentNullException("domain");
            }
            if (username == null)
            {
                throw new ArgumentNullException("username");
            }
            if (password == null)
            {
                throw new ArgumentNullException("password");
            }
            if ((domain + @"\" + username) == WindowsIdentity.GetCurrent().Name)
            {
                
            }
            else
            {
                IntPtr hToken = IntPtr.Zero;
                IntPtr hTokenDuplicate = IntPtr.Zero;
                WindowsImpersonationContext impersonationContext = null;
                try
                {
                    if (!LogonUser(username, domain, password, LogonType.LOGON32_LOGON_INTERACTIVE, ProviderType.LOGON32_PROVIDER_DEFAULT, out hToken))
                    {
                        throw new Exception(new Win32Exception().Message);
                    }
                    if (!DuplicateToken(hToken, 2, out hTokenDuplicate))
                    {
                        throw new Exception(new Win32Exception().Message);
                    }
                    impersonationContext = new WindowsIdentity(hTokenDuplicate).Impersonate();
                    //op();
                }
                finally
                {
                    if (impersonationContext != null)
                    {
                        impersonationContext.Undo();
                    }
                    if (hToken != IntPtr.Zero)
                    {
                        CloseHandle(hToken);
                    }
                    if (hTokenDuplicate != IntPtr.Zero)
                    {
                        CloseHandle(hTokenDuplicate);
                    }
                }
            }
        }

 

        static void Main(string[] args)
        {
            Invoke("tableuser","tableuser","liviutrifoi-7PC");
        }
    }
}
